glibmm: Gio::UnixInputStream Class Reference

glibmm 2.61.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::UnixInputStream Class Reference
Stream Classes

UnixInputStream implements InputStream for reading from a unix file descriptor, including asynchronous operations. More...

`#include </home/kjell/checkout/gnome/glibmm/gio/giomm/unixinputstream.h>`

Inheritance diagram for Gio::UnixInputStream:
[legend]

## Public Member Functions
| UnixInputStream (UnixInputStream&& src) noexcept
UnixInputStream& | operator= (UnixInputStream&& src) noexcept
| ~UnixInputStream () noexcept override
GUnixInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GUnixInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GUnixInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_close_fd (bool close_fd=true)
| Sets whether the file descriptor of stream shall be closed when the stream is closed. More...
bool | get_close_fd () const
| Returns whether the file descriptor of stream will be closed when the stream is closed. More...
int | get_fd () const
| Return the UNIX file descriptor that the stream reads from. More...
Glib::PropertyProxy_ReadOnly< int > | property_fd () const
| The file descriptor that the stream reads from. More...
Glib::PropertyProxy< bool > | property_close_fd ()
| Whether to close the file descriptor when the stream is closed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_close_fd () const
| Whether to close the file descriptor when the stream is closed. More...
Public Member Functions inherited from Gio::InputStream
| InputStream (InputStream&& src) noexcept
InputStream& | operator= (InputStream&& src) noexcept
| ~InputStream () noexcept override
GInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
gssize | read (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
gssize | read (void* buffer, gsize count)
| A read() convenience overload. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read)
| A read_all() convenience overload. More...
Glib::RefPtr< Glib::Bytes > | read_bytes (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Like g_input_stream_read(), this tries to read count bytes from the stream in a blocking fashion. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
Glib::RefPtr< Glib::Bytes > | read_bytes_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read-into-Bytes operation. More...
gssize | skip (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to skip count bytes from the stream. More...
gssize | skip (gsize count)
| A skip() convenience overload. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
gssize | read_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read operation. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
bool | read_all_finish (const Glib::RefPtr< AsyncResult >& result, gsize& bytes_read)
| Finishes an asynchronous stream read operation started with g_input_stream_read_all_async(). More...
void | skip_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
void | skip_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
gssize | skip_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes a stream skip operation. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
gboolean | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async(). More...
bool | is_closed () const
| Checks if an input stream is closed. More...
bool | has_pending () const
| Checks if an input stream has pending actions. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
PropertyType | get_property (const Glib::ustring& property_name) const
| You probably want to use a specific property_*() accessor method instead. More...
sigc::connection | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void()>& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void()>&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::PollableInputStream
| PollableInputStream (PollableInputStream&& src) noexcept
PollableInputStream& | operator= (PollableInputStream&& src) noexcept
| ~PollableInputStream () noexcept override
GPollableInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GPollableInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
bool | can_poll () const
| Checks if stream is actually pollable. More...
bool | is_readable () const
| Checks if stream can be read. More...
gssize | read_nonblocking (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Attempts to read up to count bytes from stream into buffer, as with g_input_stream_read(). More...
gssize | read_nonblocking (void* buffer, gsize count)
| A read_nonblocking() convenience overload. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Gio::FileDescriptorBased
| FileDescriptorBased (FileDescriptorBased&& src) noexcept
FileDescriptorBased& | operator= (FileDescriptorBased&& src) noexcept
| ~FileDescriptorBased () noexcept override
GFileDescriptorBased* | gobj ()
| Provides access to the underlying C GObject. More...
const GFileDescriptorBased* | gobj () const
| Provides access to the underlying C GObject. More...
int | get_fd () const
| Gets the underlying file descriptor. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< UnixInputStream > | create (int fd, bool close_fd)
Static Public Member Functions inherited from Gio::InputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::PollableInputStream
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::FileDescriptorBased
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| UnixInputStream (int fd, bool close_fd)
Protected Member Functions inherited from Gio::InputStream
| InputStream ()
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
virtual gssize | read_vfunc (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
virtual gssize | skip_vfunc (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
virtual bool | close_vfunc (const Glib::RefPtr< Cancellable >& cancellable)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::PollableInputStream
| PollableInputStream ()
| You should derive from this class to use it. More...
virtual bool | can_poll_vfunc () const
virtual bool | is_readable_vfunc () const
virtual gssize | read_nonblocking_vfunc (void* buffer, gsize count)
Protected Member Functions inherited from Gio::FileDescriptorBased
| FileDescriptorBased ()
| You should derive from this class to use it. More...
virtual int | get_fd_vfunc () const

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixInputStream > | wrap (GUnixInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::PollableInputStream
Glib::RefPtr< Gio::PollableInputStream > | wrap (GPollableInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::FileDescriptorBased
Glib::RefPtr< Gio::FileDescriptorBased > | wrap (GFileDescriptorBased* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

UnixInputStream implements InputStream for reading from a unix file descriptor, including asynchronous operations.

The file descriptor must be selectable, so it doesn't work with opened files.

Since glibmm 2.16:

## Constructor & Destructor Documentation

Gio::UnixInputStream::UnixInputStream | ( | UnixInputStream&& | src | ) |
| noexcept

Gio::UnixInputStream::~UnixInputStream | ( |  | ) |
| overridenoexcept

Gio::UnixInputStream::UnixInputStream | ( | int | fd,
|  | bool | close_fd
| ) |  |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<UnixInputStream> Gio::UnixInputStream::create | ( | int | fd,
|  | bool | close_fd
| ) |  |
| static

bool Gio::UnixInputStream::get_close_fd | ( |  | ) | const

Returns whether the file descriptor of stream will be closed when the stream is closed.

Since glibmm 2.20:

Returns
  `true` if the file descriptor is closed when done.

int Gio::UnixInputStream::get_fd | ( |  | ) | const

Return the UNIX file descriptor that the stream reads from.

Since glibmm 2.20:

Returns
  The file descriptor of stream.

static GType Gio::UnixInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GUnixInputStream* Gio::UnixInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GUnixInputStream* Gio::UnixInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GUnixInputStream* Gio::UnixInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

UnixInputStream& Gio::UnixInputStream::operator= | ( | UnixInputStream&& | src | ) |
| noexcept

Glib::PropertyProxy< bool > Gio::UnixInputStream::property_close_fd | ( |  | ) |

Whether to close the file descriptor when the stream is closed.

Since glibmm 2.20:

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::UnixInputStream::property_close_fd | ( |  | ) | const

Whether to close the file descriptor when the stream is closed.

Since glibmm 2.20:

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gio::UnixInputStream::property_fd | ( |  | ) | const

The file descriptor that the stream reads from.

Since glibmm 2.20:

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gio::UnixInputStream::set_close_fd | ( | bool | close_fd = `true` | ) |

Sets whether the file descriptor of stream shall be closed when the stream is closed.

Since glibmm 2.20:

Parameters

  close_fd | `true` to close the file descriptor when done.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixInputStream > wrap | ( | GUnixInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.